<?php
/**
 * Bildergalerie innerhalb von PmWiki anzeigen
 *
 * @author Stefan Jahn <stefan.jahn@nemesis-sektor.de>
 * @copyright Copyright (C) 2004 Stefan Jahn <stefan.jahn@nemesis-sektor.de>
 * @license  http://www.gnu.org/licenses/gpl.html GNU General Public License
 */


/*
 * Copyright (C) 2004 Stefan Jahn <stefan.jahn@nemesis-sektor.de>
 *
 * gallery.php is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SJ Websystem is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

SDV($InlineReplacements['/\\[\\[\\$Gallery\\]\\]/e'], 'gallery()');

// EXIF- und IPTC-Funktionen an-/abschalten
SDV($gallery_exif, TRUE);
SDV($gallery_iptc, TRUE);

// Texte
SDV($gallery_nouploads, 'Noch keine Anhnge in dieser Gruppe vorhanden.');
SDV($gallery_nopictures, 'Es sind noch keine Bilder vorhanden.');
SDV($gallery_picturename, 'Bild #');
SDV($gallery_of, 'von');
SDV($gallery_content, 'bersicht');
SDV($gallery_upload, 'Bild hochladen');
SDV($gallery_originalpicture, 'Originalbild');
SDV($gallery_city, 'Ort');
SDV($gallery_country, 'Land');

// Please remove remarks for english translation
/*
SDV($gallery_nouploads, 'No attachments in this group.');
SDV($gallery_nopictures, 'No pictures found.');
SDV($gallery_picturename, 'Picture #');
SDV($gallery_of, 'of');
SDV($gallery_content, 'Overview');
SDV($gallery_upload, 'Upload picture');
SDV($gallery_originalpicture, 'original picture');
SDV($gallery_city, 'City');
SDV($gallery_country, 'Country');
*/

SDV($gallery_titlestart, '<h2>');
SDV($gallery_titleend, '</h2>');


/**
 * Hauptroutine - Entweder Galerie oder einzelnes Bild anzeigen
 */
function gallery() {
	global $pagename;
	global $UploadDir;
	global $UploadUrlFmt;
	
	global $gallery_nouploads;
	global $gallery_nopictures;
	global $gallery_upload;

	// Pfad bestimmen
	$server = 'http://'.$_SERVER['SERVER_NAME'].'/';
	$directory = str_replace($server, '', $UploadUrlFmt);
	$directory = str_replace($UploadDir, '', $directory);
	$script = $_SERVER['PHP_SELF'];
	$pic = $_GET['pic'];
	
	// Wiki-Werte einlesen
	$array = explode('.', $pagename);
	$path = $UploadDir.'/'.$array[0];
	$url = $UploadUrlFmt.'/'.$array[0].'/';
	$name = strtolower($array[1]);
	$suffix = $name.'_';

	// Prfen ob Verzeichnis vorhanden ist
	if (!is_dir($path)) {
		echo $gallery_nouploads."\n";
		if ($gallery_upload != '') echo '<a href="'.$script.'?action=upload&amp;upname='.$suffix.'" title="'.$gallery_upload.'">'.$gallery_upload.'</a>'."\n";
		return;
	}
	
	$path.= '/';

	// Verzeichnis einlesen
	$array = gallery_readdir($path, $suffix);
	$image = $array[1];
	$thumbnail = $array[2];
	$original = $array[3];

	// Bilder zhlen	
	$max = count($image);

	// Prfen ob Bilder vorhanden sind
	if ($max == 0) {
		echo $gallery_nopictures."\n";
		if ($gallery_upload != '') echo '<a href="'.$script.'?action=upload&amp;upname='.$suffix.'" title="'.$gallery_upload.'">'.$gallery_upload.'</a>'."\n";
		return;
	}

	// Parameter prfen
	if (isset($pic)) {
		if ($pic > $max) $pic = $max;
		if ($pic < 1) $pic = 1;
	}

	// Gallerie oder einzelnes Bild anzeigen
	if (!isset($pic)) gallery_displaythumbnails($thumbnail, $image, $directory, $suffix, $max);
	else gallery_displayimage($image, $directory, $suffix, $max, $pic, $original);

	return;
}


/**
 * Thumbnail erzeugen
 *
 * @param string $image Dateiname des Bildes
 * @param string $thumbnail Dateiname des Thumbnails
 */
function gallery_createthumbnail($image, $thumbnail) {
	// Infos ber Bild holen
	$info = getimagesize($image);
	$width = $info[0];
	$height = $info[1];
	$type = $info[2];

	// Thumbnail erstellen
	if ($type == 1) $new = imagecreatefromgif($image);
	elseif ($type == 2) $new = imagecreatefromjpeg($image);
	elseif ($type == 3) $new = imagecreatefrompng($image);

	$newwidth = 100;
	$newheight = $height/($width/$newwidth);
	$newimage = imagecreatetruecolor($newwidth, $newheight);
	imagecopyresampled($newimage, $new, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);

	if ($type == 1) imagegif($newimage, $thumbnail);
	elseif ($type == 2) imagejpeg($newimage, $thumbnail);
	elseif ($type == 3) imagepng($newimage, $thumbnail);
}


/**
 * Navigation anzeigen
 *
 * @param integer $pic Aktuelle Bild
 * @param integer $max Anzahl der Bilder
 */
function gallery_navigation($pic, $max) {
	global $gallery_picturename;
	global $gallery_content;
	
	$script = $_SERVER['PHP_SELF'];
	
	if ($pic > 1) {
		echo '<a href="'.$script.'?pic=1" title="'.$gallery_picturename.'1">&lt;&lt;</a>&nbsp;'."\n";
		echo '<a href="'.$script.'?pic='.($pic-1).'" title="'.$gallery_picturename.($pic-1).'">&lt;</a>&nbsp;'."\n";
	} else {
		echo '&lt;&lt;&nbsp;'."\n";
		echo '&lt;&nbsp;'."\n";
	}

	echo '<a href="'.$script.'" title="'.$gallery_content.'">'.$gallery_content.'</a>&nbsp;'."\n";

	if ($pic < $max) {
		echo '<a href="'.$script.'?pic='.($pic+1).'" title="'.$gallery_picturename.($pic+1).'">&gt;</a>&nbsp;'."\n";
		echo '<a href="'.$script.'?pic='.($max).'" title="'.$gallery_picturename.($max).'">&gt;&gt;</a>'."\n";
	} else {
		echo '&gt;&nbsp;'."\n";
		echo '&gt;&gt;'."\n";
	}

	flush();
	
	return;
}


/**
 * Verzeichnis einlesen
 *
 * @param string $path Pfad zum Upload-Verzeichnis der aktuellen Seite des Wikis
 * @param string $suffix Titel der aktuellen Seite des Wikis
 * @return array
 */
function gallery_readdir($path, $suffix) {
	$dir = dir($path);
	while ($file = $dir->read()) {
		$filename = strtolower($file);
		if (!stristr($filename, 'thumb_') and stristr($filename, $suffix) and !stristr($filename, 'original_')) {
			if (stristr($filename, '.jpg')) {
				$image[] = $path.$filename;
				$thumbnail[] = $path.'thumb_'.$filename;
				$original[] = $path.'original_'.$filename;
			}
			if (stristr($filename, '.png')) {
				$image[] = $path.$filename;
				$thumbnail[] = $path.'thumb_'.$filename;
				$original[] = $path.'original_'.$filename;
			}
			if (stristr($filename, '.gif')) {
				$image[] = $path.$filename;
				$thumbnail[] = $path.'thumb_'.$filename;
				$original[] = $path.'original_'.$filename;
			}
		}
	}
	$dir->close();

	// Inhaltsverzeichnis sortieren	
	sort($image);
	sort($thumbnail);
	sort($original);

	$array[1] = $image;
	$array[2] = $thumbnail;
	$array[3] = $original;
	
	return $array;
}


/**
 * Thumbnails anzeigen
 *
 * @param array $thumbnail Dateinamen der Thumbnails
 * @param array $image Dateinamen der Bilder
 * @param array $directory Wiki-Verzeichnis
 * @param string $suffix Titel der aktuellen Seite des Wikis
 * @param integer $max Anzahl der Bilder
 */
function gallery_displaythumbnails($thumbnail, $image, $directory, $suffix, $max) {
	global $gallery_picturename;
	global $gallery_upload;
	global $gallery_iptc;
	
	$script = $_SERVER['PHP_SELF'];
	
	echo '<div style="text-align:center">'."\n";
	for ($i = 0; $i < $max; $i++):
		// Thumbnail erzeugen falls nicht vorhanden ist
		if (!file_exists($thumbnail[$i])) gallery_createthumbnail($image[$i], $thumbnail[$i]);

		$size = getimagesize($thumbnail[$i]);
		getimagesize($image[$i], $info);

		// IPTC-Daten ermitteln
		if (isset($info["APP13"]) and $gallery_iptc) {
			$iptc = iptcparse($info['APP13']);
			$iptc_caption = htmlentities($iptc['2#120'][0]);
			if ($iptc_caption != '') $iptc_caption = ' - '.$iptc_caption;
		} else unset($iptc_caption);
		
		// Thumbnail anzeigen
		echo '<a href="'.$script.'?pic='.($i+1).'" title="'.$gallery_picturename.($i+1).$iptc_caption.'"><img class="thumb" src="/'.$directory.$thumbnail[$i].'" alt="'.$gallery_picturename.($i+1).$iptc_caption.'" '.$size[3].' /></a>'."\n";
		flush();
	endfor;
	echo '</div>'."\n";

	if ($gallery_upload != '') {
		echo '<div style="text-align:right">'."\n";
		echo '<a href="'.$script.'?action=upload&amp;upname='.$suffix.'" title="'.$gallery_upload.'">'.$gallery_upload.'</a>'."\n";
		echo '</div>'."\n";
	}

	flush();
}


/**
 * Bild anzeigen
 *
 * @param array $image Dateinamen der Bilder
 * @param array $directory Wiki-Verzeichnis
 * @param string $suffix Titel der aktuellen Seite des Wikis
 * @param integer $max Anzahl der Bilder
 * @param integer $pic Nummer des aktuellen Bildes
 * @param array $image Dateinamen der original Bilder
 */
function gallery_displayimage($image, $directory, $suffix, $max, $pic, $original) {
	global $gallery_picturename;
	global $gallery_of;
	global $gallery_titlestart;
	global $gallery_titleend;
	global $gallery_originalpicture;
	global $gallery_city;
	global $gallery_country;
	global $gallery_exif;
	global $gallery_iptc;

	$size = getimagesize($image[$pic-1], $info);

	// EXIF-Daten ermitteln
	if ($gallery_exif) {
		$exif = exif_read_data($image[$pic-1]);
		$exif_date = htmlentities($exif['DateTime']);
		$exif_make = htmlentities($exif['MAKE'][0]);
		$exif_camera = htmlentities($exif['MODEL'][0]);
	}

	// IPTC-Daten ermitteln
	if (isset($info["APP13"]) and $gallery_iptc) {
		$iptc = iptcparse ($info['APP13']);
		$iptc_program = htmlentities($iptc['2#065'][0]);
		$iptc_jobid = htmlentities($iptc['2#022'][0]);
		$iptc_status = htmlentities($iptc['2#007'][0]);
		$iptc_copyright = htmlentities($iptc['2#116'][0]);
		$iptc_specialinstructions = htmlentities($iptc['2#040'][0]);
		$iptc_headline = htmlentities($iptc['2#105'][0]);
		$iptc_captionwriter = htmlentities($iptc['2#122'][0]);
		$iptc_caption = htmlentities($iptc['2#120'][0]);
		$iptc_originaltransmissionreference = htmlentities($iptc['2#103'][0]);
		$iptc_countrycode = htmlentities($iptc['2#100'][0]);
		$iptc_country = htmlentities($iptc['2#101'][0]);
		$iptc_state = htmlentities($iptc['2#095'][0]);
		$iptc_sublocation = htmlentities($iptc['2#092'][0]);
		$iptc_city = htmlentities($iptc['2#090'][0]);
		$iptc_objectname = htmlentities($iptc['2#005'][0]);
		$iptc_source = htmlentities($iptc['2#115'][0]);
		$iptc_credit = htmlentities($iptc['2#110'][0]);
		$iptc_bylinetitle = htmlentities($iptc['2#085'][0]);
		$iptc_byline = htmlentities($iptc['2#080'][0]);
	} else {
		unset($iptc_program);
		unset($iptc_jobid);
		unset($iptc_status);
		unset($iptc_copyright);
		unset($iptc_specialinstructions);
		unset($iptc_headline);
		unset($iptc_captionwriter);
		unset($iptc_caption);
		unset($iptc_originaltransmissionreference);
		unset($iptc_countrycode);
		unset($iptc_country);
		unset($iptc_state);
		unset($iptc_sublocation);
		unset($iptc_city);
		unset($iptc_objectname);
		unset($iptc_source);
		unset($iptc_credit);
		unset($iptc_bylinetitle);
		unset($iptc_byline);
	}
	
	echo $gallery_titlestart.$gallery_picturename.($pic).' '.$gallery_of.' '.$max.$gallery_titleend."\n";

	// Bild anzeigen
	echo '<div style="text-align:center">'."\n";
	echo '<img class="photo" src="/'.$directory.$image[$pic-1].'" alt="'.$gallery_picturename.($pic).' '.$gallery_of.' '.$max.'" '.$size[3].' />'."\n";
	echo '<br />'."\n";

	// Beschreibung anzeigen
	if ($exif_date != '' and $gallery_exif) {
		echo $exif_date."\n";
		echo '<br />'."\n";
	}
	
	if ($gallery_iptc) {
		if ($iptc_caption != '') {
			echo $iptc_caption."\n";
			echo '<br />'."\n";
		}
		if ($iptc_city != '') {
			echo $gallery_city.': '.$iptc_city;
			if ($iptc_country != '') echo ', '.$iptc_country;
			echo '<br />'."\n";
		} elseif ($iptc_country != '') {
			echo $gallery_country.': '.$iptc_country."\n";
			echo '<br />'."\n";
		}
		if ($iptc_sublocation != '') {
			echo $iptc_sublocation."\n";
			echo '<br />'."\n";
		}
	}

	echo '<br />'."\n";

	// Navigation anzeigen
	gallery_navigation($pic, $max);

	if (file_exists($original[$pic-1])) {
		echo '<br />'."\n";
		echo '<a href="/'.$original[$pic-1].'" title="'.$gallery_picturename.($pic).'" target="_blank">'.$gallery_originalpicture.'</a>'."\n";
	}

	echo '</div>'."\n";

	flush();
}
?>
